#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>
main(argc, argv)
int argc;
char **argv;
{
   Display *d;     Window w;
   XEvent e;       char hname[64], *cl[4];
   Atom a1, a2;    XTextProperty tp;

   setlocale (LC_ALL, "");
   d = XOpenDisplay (NULL);
   w = XCreateSimpleWindow (d, RootWindow (d, 0), 200, 300,
                            200, 100, 2, 0, 1);
   gethostname (hname, 64);
   cl[0] = hname;
   XmbTextListToTextProperty (d, cl, 1, XStringStyle, &tp);
   XSetWMClientMachine (d, w, &tp);

   a1 = XInternAtom (d, "WM_PROTOCOLS", False);
   a2 = XInternAtom (d, "WM_SAVE_YOURSELF", False);
   XSetWMProtocols (d, w, &a2, 1);

   XMapWindow (d, w);
   while (1)
     { XNextEvent (d, &e);
       if (e.type == ClientMessage && e.xclient.message_type == a1
                                   && e.xclient.data.l[0] == a2)
           XSetCommand (d, w, argv, argc);
     }
}
